program BinaryTree;
type tree = ^treetype;
     treetype = record
                    val         : integer;
                    left, right : tree;
                end;

procedure Add ( var root : tree; data: integer );
begin
    if root = nil then
    begin
        new(root);
        root^.val := data;
        root^.left := nil;
        root^.right := nil;
    end
    else
    if data < root^.val then Add(root^.left,data) else
    if data > root^.val then Add(root^.right,data);
    //Vienodu elementu tiesiog nededa

end;

procedure MaxHeap( root : tree);
var temp : tree;
    tempdata : integer;
begin
    temp := root ;
    while (root^.right <> nil) do
    root := root^.right;
    tempdata := temp^.val ;
    temp^.val := root^.val ;
    root^.val := tempdata;
end;

function search ( treeval : tree; value: integer) : boolean;
begin
    if treeval = nil then search := false
    else
    if value > treeval^.val then search:=search(treeval^.right, value)
    else
    if value < treeval^.val then search:=search(treeval^.left, value)
    else
    search := true;
end;

procedure printFile(var f: text ; treeval : tree);          //PREODER  - virsune , kaire , desine
begin
    if treeval <> nil then
    begin
        writeln(f,treeval^.val);
        printFile(f,treeval^.left);
        printFile(f,treeval^.right);
    end;
end;
var root : tree  ;  //Sakninis elementas
    f    : text;
begin
  WriteLn('Binary tree');
  writeln('----------');
  Assign(f,'Rezults.txt');
  Rewrite(f);
  Add(root, 8);
  Add(root, 12);
  Add(root, 17);
  Add(root, 4);
  Add(root, 8);
  Add(root, 12);
  Add(root, 2);
  Add(root, 14);
  Add(root, 3);
  Add(root, 13);
  Add(root, 15);
  writeln(f,'Pries maxHeap:');
  printFile(f,root);
  maxHeap(root);
  writeln(f,'Po maxHeap:');
  printFile(f,root);
  writeln('Darbas baiktas!');
  close(f);
  Readln;
end.
